package discords;

import java.util.Vector;

import dist.DistEuclidean;

/**
 * Created by IntelliJ IDEA.
 * User: dragomir
 * Date: Oct 4, 2007
 * Time: 4:10:14 PM
 * To change this template use File | Settings | File Templates.
 */
public class MainMemory {
    public void buildMainMemory(Vector DB, double threshold, Vector vMM, Vector vVolume, Vector indxPtr, int offset) {
        for (int i = 0; i < DB.size(); i++) {
            prune_or_add((double[]) DB.get(i), vMM, indxPtr, threshold, i+offset);
        }
        vVolume.add(new Integer(vMM.size()));        
    }

    private void prune_or_add(double[] ts, Vector vMM, Vector indxPtr, double threshold, int offset) {
        DistEuclidean dist = new DistEuclidean(false, false);
        boolean toAdd = true;
        for (int i = 0; i < vMM.size();) {
            double d = dist.dist(ts, (double[]) vMM.get(i));
            if (d >= threshold) {
                i++;
            } else {
                vMM.remove(i);
                indxPtr.remove(i);
                toAdd = false;
            }
        }
        if (toAdd) {
            indxPtr.add(new Integer(offset));
            vMM.add(ts);
        }
    }
}
