package dist;

/**
 * Created by IntelliJ IDEA.
 * User: dragomir yankov
 * Date: Jun 20, 2005
 * Time: 6:37:39 PM
 * To change this template use File | Settings | File Templates.
 */
public abstract class Dist {
    public static final int DIST_EUCLID = 0;
    public static final int DIST_ROTAT = 1;

    public boolean normalized = false;
    public boolean earlyAbandon = true;
    public double currMinDist = Double.MAX_VALUE;
    public int rotation = 0;

    public abstract double dist(double[] ts1, double[] ts2);

    public Dist() {
    }
    
    public Dist(boolean earlyAbandon, boolean normalize) {
        this.earlyAbandon = earlyAbandon;
        this.normalized = normalize;
    }
}
